import tensorrt as trt
import torch

from model import MnistModel
from darknet import Darknet

TRT_LOGGER = trt.Logger(trt.Logger.WARNING)


class ModelData(object):
    INPUT_NAME = "data"
    INPUT_SHAPE = (1, 28, 28)
    OUTPUT_NAME = "prob"
    OUTPUT_SIZE = 10
    DTYPE = trt.float32


with trt.Builder(TRT_LOGGER) as builder, builder.create_network() as network:
    input_tensor = network.add_input(name=ModelData.INPUT_NAME, dtype=ModelData.DTYPE, shape=ModelData.INPUT_SHAPE)

    test_net = Darknet('./yolov3-spp.cfg')
    # test_net.load_weights('./yolov3-spp.weights')
    test_net.load_state_dict(torch.load('./yolov3-spp.pkl'))
    weights = test_net.state_dict()
    test_conv1_w = weights['module_list.0.conv_0.weight']
    test_conv1 = network.add_convolution(input=input_tensor, num_output_maps=32, kernel_shape=(3, 3), kernel=test_conv1_w)

    # net = MnistModel()
    # net.network.load_state_dict(torch.load('./net.pkl'))
    # weights = net.network.state_dict()
    # conv1_w = weights['conv1.weight'].numpy()
    # conv1_b = weights['conv1.bias'].numpy()
    # conv1 = network.add_convolution(input=input_tensor, num_output_maps=20, kernel_shape=(5, 5), kernel=conv1_w,
    #                                 bias=conv1_b)
